#include <stdio.h>

int main()
{
	int nt; scanf("%d", &nt);
	while (nt--)
	{
		int n;
		scanf("%d", &n);
		for (int i = 0; i < n; i++)
		  scanf("%*d %*d", &n);
		for (int i = 0; i < n; i++)
		  printf("%d%c", i, i == n - 1 ? '\n' : ' ');
	}
	return 0;
}
